// OK
#include <fstream>
#include <algorithm>
#include <vector>
#include <iostream>
using namespace std;

// Nmax[1] - Nr maxim de segmente vericale care se suprapun 

#define mid ((l + r) / 2 - ((l + r) % 2 && (l + r) < 0))

ifstream fin("kop.in");
ofstream fout("kop.out");

typedef pair<int, int> PII;
vector<PII> p;

int H, W, n;     // inaltime, latime
int V, a, b;     // V = 1 daca intervalul se adauga in arbore / capetele intervalului de interogare
int Res;
int Nmax[262144], Cnt[262144];

void Read();
void Solve();
void Update(int nod, int l, int r);

int main()
{
	Read();
	sort(p.begin(), p.end());
	Solve();
	fout << Res << '\n';
	fin.close();
	fout.close();

	return 0;
}

void Read()
{
	fin >> W >> H >> n;
	p.resize(n);
	for (int i = 0; i < n; ++i)
		fin >> p[i].first >> p[i].second;
}

void Solve()        // doua linii de baleiere: i si j (i, j = iteratori)
{
	for (int i = 0, j = 0; j < n;  )
	{
		for ( ; j < n and p[j].first - p[i].first <= W; ++j )
		{
			V = 1; a = p[j].second - H; b = p[j].second;
			Update(1, -40001, 40001);
		}

		Res = max(Res, Nmax[1]);

		for ( ; p[j].first - p[i].first > W; ++i)
		{
			V = -1; a = p[i].second - H; b = p[i].second;
			Update(1, -40001, 40001);
		}
	}
}

void Update(int x, int l, int r)  // suprapunerea maxima de intervale (Nmax) este nr maxim de puncte din dreptunghi
{
	if ( a <= l && r <= b )
	{
		Cnt[x] += V;  // update lazy x
		Nmax[x] += V; // update x
		return;         
	}
	
	if (l != r)  // daca nodul x are fii
	{
		Cnt[2 * x]     +=  Cnt[x];         // update lazy fii
		Cnt[2 * x + 1] +=  Cnt[x];
		Nmax[2 * x] += Cnt[x];             // update noduri fii
		Nmax[2 * x + 1] += Cnt[x];
		Cnt[x] = 0;                          // nu mai avem lazy in nod
	}

	if (a <= mid) Update(2 * x, l, mid);
	if (b > mid)  Update(2 * x + 1, mid + 1, r);

	Nmax[x] = max(Nmax[2 * x], Nmax[2 * x + 1]);
}
