// OK
#include <fstream>
#include <algorithm>
#include <vector>
#include <iostream>
using namespace std;

// Nmax[1] - Nr maxim de segmente vericale care se suprapun 

#define mid ((l + r) / 2 - ((l + r) % 2 && (l + r) < 0))
#define X first
#define Y second
ifstream fin("kop14.in");
ofstream fout("kop.out");

const int Y_MAX = 30005;  // 2^18
using PII = pair<int, int>;
vector<PII> p;

int H, W, n;     // inaltime, latime
int V, a, b;     // V = 1 daca intervalul se adauga in arbore / capetele intervalului de interogare
int Res;
int Nmax[4 * 2 * Y_MAX], Cnt[4 * 2 * Y_MAX];

void Read();
void Solve();
void Update(int nod, int l, int r);

int main()
{
	Read();
	sort(p.begin(), p.end());
	Solve();
	fout << Res << '\n';
	fin.close();
	fout.close();

	return 0;
}

void Read()
{
	fin >> W >> H >> n;
	p.resize(n);
	for (int i = 0; i < n; ++i)
		fin >> p[i].X >> p[i].Y;
}

void Solve()        // doua linii de baleiere: i si j (i, j = iteratori)
{
	for (int i = 0, j = 0; j < n;  )
	{
		for ( ; j < n and p[j].X - p[i].X <= W; ++j )
		{
			V = 1; a = p[j].Y - H; b = p[j].Y;
			Update(1, -Y_MAX, Y_MAX);
		}

		Res = max(Res, Nmax[1]);

		for ( ; p[j].X - p[i].X > W; ++i)
		{
			V = -1; a = p[i].Y - H; b = p[i].Y;
			Update(1, -Y_MAX, Y_MAX);
		}
	}
}

void Propagate(int x, int l, int r)
{
	if (Cnt[x]) // daca a fost lazy
	{
		Nmax[x] += Cnt[x];
		if (l != r)  // daca x are fii
		{
			Cnt[2 * x] += Cnt[x];
			Cnt[2 * x + 1] += Cnt[x];
		}
		Cnt[x] = 0;
	}
}

void Update(int x, int l, int r)  // suprapunerea maxima de intervale (Nmax) este nr maxim de puncte din dreptunghi
{
	Propagate(x, l, r);
	
	if ( a <= l && r <= b )
	{
		Cnt[x] += V;  // update lazy x
		Propagate(x, l, r);
		return;         
	}
	
	if (l > r || l > b || r < a) return;
	Update(2 * x, l, mid);
	Update(2 * x + 1, mid + 1, r);

	Nmax[x] = max(Nmax[2 * x], Nmax[2 * x + 1]);
}
